*** a/contrib/postgres_fdw/deparse.c
--- b/contrib/postgres_fdw/deparse.c
***************
*** 44,51 ****
--- 44,54 ----
  #include "catalog/pg_proc.h"
  #include "catalog/pg_type.h"
  #include "commands/defrem.h"
+ #include "nodes/makefuncs.h"
  #include "nodes/nodeFuncs.h"
+ #include "nodes/plannodes.h"
  #include "optimizer/clauses.h"
+ #include "optimizer/prep.h"
  #include "optimizer/var.h"
  #include "parser/parsetree.h"
  #include "utils/builtins.h"
***************
*** 92,97 **** typedef struct deparse_expr_cxt
--- 95,102 ----
  	RelOptInfo *foreignrel;		/* the foreign relation we are planning for */
  	StringInfo	buf;			/* output buffer to append to */
  	List	  **params_list;	/* exprs that will become remote Params */
+ 	List	   *outertlist;		/* outer child's target list */
+ 	List	   *innertlist;		/* inner child's target list */
  } deparse_expr_cxt;
  
  /*
***************
*** 111,117 **** static void deparseTargetList(StringInfo buf,
  				  Index rtindex,
  				  Relation rel,
  				  Bitmapset *attrs_used,
! 				  List **retrieved_attrs);
  static void deparseReturningList(StringInfo buf, PlannerInfo *root,
  					 Index rtindex, Relation rel,
  					 bool trig_after_row,
--- 116,123 ----
  				  Index rtindex,
  				  Relation rel,
  				  Bitmapset *attrs_used,
! 				  List **retrieved_attrs,
! 				  bool alias);
  static void deparseReturningList(StringInfo buf, PlannerInfo *root,
  					 Index rtindex, Relation rel,
  					 bool trig_after_row,
***************
*** 139,144 **** static void printRemoteParam(int paramindex, Oid paramtype, int32 paramtypmod,
--- 145,151 ----
  				 deparse_expr_cxt *context);
  static void printRemotePlaceholder(Oid paramtype, int32 paramtypmod,
  					   deparse_expr_cxt *context);
+ static const char *get_jointype_name(JoinType jointype);
  
  
  /*
***************
*** 261,267 **** foreign_expr_walker(Node *node,
  				 * Param's collation, ie it's not safe for it to have a
  				 * non-default collation.
  				 */
! 				if (var->varno == glob_cxt->foreignrel->relid &&
  					var->varlevelsup == 0)
  				{
  					/* Var belongs to foreign table */
--- 268,274 ----
  				 * Param's collation, ie it's not safe for it to have a
  				 * non-default collation.
  				 */
! 				if (bms_is_member(var->varno, glob_cxt->foreignrel->relids) &&
  					var->varlevelsup == 0)
  				{
  					/* Var belongs to foreign table */
***************
*** 703,720 **** deparse_type_name(Oid type_oid, int32 typemod)
   *
   * We also create an integer List of the columns being retrieved, which is
   * returned to *retrieved_attrs.
   */
  void
  deparseSelectSql(StringInfo buf,
  				 PlannerInfo *root,
  				 RelOptInfo *baserel,
  				 Bitmapset *attrs_used,
! 				 List **retrieved_attrs)
  {
  	RangeTblEntry *rte = planner_rt_fetch(baserel->relid, root);
  	Relation	rel;
  
  	/*
  	 * Core code already has some lock on each rel being planned, so we can
  	 * use NoLock here.
  	 */
--- 710,798 ----
   *
   * We also create an integer List of the columns being retrieved, which is
   * returned to *retrieved_attrs.
+  *
+  * The relations is a string buffer for "Relations" portion of EXPLAIN output,
+  * or NULL if caller doesn't need it.  Note that it should have been
+  * initialized by caller.
+  *
+  * The alias is a flag to add aliases of columns and tables.  This should be
+  * false in the initial call, and will be set true when this function is called
+  * for building a part of a join query.
   */
  void
  deparseSelectSql(StringInfo buf,
  				 PlannerInfo *root,
  				 RelOptInfo *baserel,
  				 Bitmapset *attrs_used,
! 				 List *remote_conds,
! 				 List *pathkeys,
! 				 List **params_list,
! 				 List **fdw_scan_tlist,
! 				 List **retrieved_attrs,
! 				 StringInfo relations,
! 				 bool alias)
  {
+ 	PgFdwRelationInfo  *fpinfo = (PgFdwRelationInfo *) baserel->fdw_private;
  	RangeTblEntry *rte = planner_rt_fetch(baserel->relid, root);
  	Relation	rel;
  
  	/*
+ 	 * If given relation was a join relation, recursively construct statement
+ 	 * by putting each outer and inner relations in FROM clause as a subquery
+ 	 * with aliasing.
+ 	 */
+ 	if (baserel->reloptkind == RELOPT_JOINREL)
+ 	{
+ 		RelOptInfo		   *rel_o = fpinfo->outerrel;
+ 		RelOptInfo		   *rel_i = fpinfo->innerrel;
+ 		PgFdwRelationInfo  *fpinfo_o = (PgFdwRelationInfo *) rel_o->fdw_private;
+ 		PgFdwRelationInfo  *fpinfo_i = (PgFdwRelationInfo *) rel_i->fdw_private;
+ 		StringInfoData		sql_o;
+ 		StringInfoData		sql_i;
+ 		List			   *ret_attrs_tmp;	/* not used */
+ 		StringInfoData		relations_o;
+ 		StringInfoData		relations_i;
+ 		const char		   *jointype_str;
+ 
+ 		/*
+ 		 * Deparse query for outer and inner relation, and combine them into
+ 		 * a query.
+ 		 *
+ 		 * Here we don't pass fdw_scan_tlist because targets of underlying
+ 		 * relations are already put in joinrel->reltargetlist, and
+ 		 * deparseJoinRel() takes all care about it.
+ 		 */
+ 		initStringInfo(&sql_o);
+ 		initStringInfo(&relations_o);
+ 		deparseSelectSql(&sql_o, root, rel_o, fpinfo_o->attrs_used,
+ 						 fpinfo_o->remote_conds, NIL, params_list,
+ 						 NULL, &ret_attrs_tmp, &relations_o, true);
+ 		initStringInfo(&sql_i);
+ 		initStringInfo(&relations_i);
+ 		deparseSelectSql(&sql_i, root, rel_i, fpinfo_i->attrs_used,
+ 						 fpinfo_i->remote_conds, NIL, params_list,
+ 						 NULL, &ret_attrs_tmp, &relations_i, true);
+ 
+ 		/* For EXPLAIN output */
+ 		jointype_str = get_jointype_name(fpinfo->jointype);
+ 		if (relations)
+ 			appendStringInfo(relations, "(%s) %s JOIN (%s)",
+ 							 relations_o.data, jointype_str, relations_i.data);
+ 
+ 		deparseJoinSql(buf, root, baserel,
+ 					   fpinfo->outerrel,
+ 					   fpinfo->innerrel,
+ 					   sql_o.data,
+ 					   sql_i.data,
+ 					   fpinfo->jointype,
+ 					   fpinfo->joinclauses,
+ 					   fpinfo->otherclauses,
+ 					   fdw_scan_tlist,
+ 					   retrieved_attrs);
+ 		return;
+ 	}
+ 
+ 	/*
  	 * Core code already has some lock on each rel being planned, so we can
  	 * use NoLock here.
  	 */
***************
*** 725,731 **** deparseSelectSql(StringInfo buf,
  	 */
  	appendStringInfoString(buf, "SELECT ");
  	deparseTargetList(buf, root, baserel->relid, rel, attrs_used,
! 					  retrieved_attrs);
  
  	/*
  	 * Construct FROM clause
--- 803,809 ----
  	 */
  	appendStringInfoString(buf, "SELECT ");
  	deparseTargetList(buf, root, baserel->relid, rel, attrs_used,
! 					  retrieved_attrs, alias);
  
  	/*
  	 * Construct FROM clause
***************
*** 733,738 **** deparseSelectSql(StringInfo buf,
--- 811,901 ----
  	appendStringInfoString(buf, " FROM ");
  	deparseRelation(buf, rel);
  
+ 	/*
+ 	 * Return local relation name for EXPLAIN output.
+ 	 * We can't know VERBOSE option is specified or not, so always add shcema
+ 	 * name.
+ 	 */
+ 	if (relations)
+ 	{
+ 		const char	   *namespace;
+ 		const char	   *relname;
+ 		const char	   *refname;
+ 
+ 		namespace = get_namespace_name(get_rel_namespace(rte->relid));
+ 		relname = get_rel_name(rte->relid);
+ 		refname = rte->eref->aliasname;
+ 		appendStringInfo(relations, "%s.%s",
+ 						 quote_identifier(namespace),
+ 						 quote_identifier(relname));
+ 		if (*refname && strcmp(refname, relname) != 0)
+ 			appendStringInfo(relations, " %s",
+ 							 quote_identifier(rte->eref->aliasname));
+ 	}
+ 
+ 	/*
+ 	 * Construct WHERE clause
+ 	 */
+ 	if (remote_conds)
+ 		appendConditions(buf, root, baserel, NULL, NULL, remote_conds,
+ 						 " WHERE ", params_list);
+ 
+ 	/* Add ORDER BY clause if we found any useful pathkeys */
+ 	if (pathkeys)
+ 		appendOrderByClause(buf, root, baserel, pathkeys);
+ 
+ 	/*
+ 	 * Add FOR UPDATE/SHARE if appropriate.  We apply locking during the
+ 	 * initial row fetch, rather than later on as is done for local tables.
+ 	 * The extra roundtrips involved in trying to duplicate the local
+ 	 * semantics exactly don't seem worthwhile (see also comments for
+ 	 * RowMarkType).
+ 	 *
+ 	 * Note: because we actually run the query as a cursor, this assumes
+ 	 * that DECLARE CURSOR ... FOR UPDATE is supported, which it isn't
+ 	 * before 8.3.
+ 	 */
+ 	if (baserel->relid == root->parse->resultRelation &&
+ 		(root->parse->commandType == CMD_UPDATE ||
+ 		 root->parse->commandType == CMD_DELETE))
+ 	{
+ 		/* Relation is UPDATE/DELETE target, so use FOR UPDATE */
+ 		appendStringInfoString(buf, " FOR UPDATE");
+ 	}
+ 	else
+ 	{
+ 		PlanRowMark *rc = get_plan_rowmark(root->rowMarks, baserel->relid);
+ 
+ 		if (rc)
+ 		{
+ 			/*
+ 			 * Relation is specified as a FOR UPDATE/SHARE target, so handle
+ 			 * that.  (But we could also see LCS_NONE, meaning this isn't a
+ 			 * target relation after all.)
+ 			 *
+ 			 * For now, just ignore any [NO] KEY specification, since (a)
+ 			 * it's not clear what that means for a remote table that we
+ 			 * don't have complete information about, and (b) it wouldn't
+ 			 * work anyway on older remote servers.  Likewise, we don't
+ 			 * worry about NOWAIT.
+ 			 */
+ 			switch (rc->strength)
+ 			{
+ 				case LCS_NONE:
+ 					/* No locking needed */
+ 					break;
+ 				case LCS_FORKEYSHARE:
+ 				case LCS_FORSHARE:
+ 					appendStringInfoString(buf, " FOR SHARE");
+ 					break;
+ 				case LCS_FORNOKEYUPDATE:
+ 				case LCS_FORUPDATE:
+ 					appendStringInfoString(buf, " FOR UPDATE");
+ 					break;
+ 			}
+ 		}
+ 	}
+ 
  	heap_close(rel, NoLock);
  }
  
***************
*** 749,755 **** deparseTargetList(StringInfo buf,
  				  Index rtindex,
  				  Relation rel,
  				  Bitmapset *attrs_used,
! 				  List **retrieved_attrs)
  {
  	TupleDesc	tupdesc = RelationGetDescr(rel);
  	bool		have_wholerow;
--- 912,919 ----
  				  Index rtindex,
  				  Relation rel,
  				  Bitmapset *attrs_used,
! 				  List **retrieved_attrs,
! 				  bool alias)
  {
  	TupleDesc	tupdesc = RelationGetDescr(rel);
  	bool		have_wholerow;
***************
*** 780,785 **** deparseTargetList(StringInfo buf,
--- 944,952 ----
  			first = false;
  
  			deparseColumnRef(buf, rtindex, i, root);
+ 			if (alias)
+ 				appendStringInfo(buf, " a%d",
+ 								 i - FirstLowInvalidHeapAttributeNumber);
  
  			*retrieved_attrs = lappend_int(*retrieved_attrs, i);
  		}
***************
*** 797,802 **** deparseTargetList(StringInfo buf,
--- 964,972 ----
  		first = false;
  
  		appendStringInfoString(buf, "ctid");
+ 		if (alias)
+ 			appendStringInfo(buf, " a%d",
+ 							 SelfItemPointerAttributeNumber - FirstLowInvalidHeapAttributeNumber);
  
  		*retrieved_attrs = lappend_int(*retrieved_attrs,
  									   SelfItemPointerAttributeNumber);
***************
*** 808,818 **** deparseTargetList(StringInfo buf,
  }
  
  /*
!  * Deparse WHERE clauses in given list of RestrictInfos and append them to buf.
   *
   * baserel is the foreign table we're planning for.
   *
!  * If no WHERE clause already exists in the buffer, is_first should be true.
   *
   * If params is not NULL, it receives a list of Params and other-relation Vars
   * used in the clauses; these values must be transmitted to the remote server
--- 978,990 ----
  }
  
  /*
!  * Deparse conditions, such as WHERE clause and ON clause of JOIN, in the given
!  * list, consist of RestrictInfo or Expr, and append string representation of
!  * them to buf.
   *
   * baserel is the foreign table we're planning for.
   *
!  * prefix is placed before the conditions, if any.
   *
   * If params is not NULL, it receives a list of Params and other-relation Vars
   * used in the clauses; these values must be transmitted to the remote server
***************
*** 822,837 **** deparseTargetList(StringInfo buf,
   * so Params and other-relation Vars should be replaced by dummy values.
   */
  void
! appendWhereClause(StringInfo buf,
! 				  PlannerInfo *root,
! 				  RelOptInfo *baserel,
! 				  List *exprs,
! 				  bool is_first,
! 				  List **params)
  {
  	deparse_expr_cxt context;
  	int			nestlevel;
  	ListCell   *lc;
  
  	if (params)
  		*params = NIL;			/* initialize result list to empty */
--- 994,1012 ----
   * so Params and other-relation Vars should be replaced by dummy values.
   */
  void
! appendConditions(StringInfo buf,
! 				 PlannerInfo *root,
! 				 RelOptInfo *baserel,
! 				 List *outertlist,
! 				 List *innertlist,
! 				 List *exprs,
! 				 const char *prefix,
! 				 List **params)
  {
  	deparse_expr_cxt context;
  	int			nestlevel;
  	ListCell   *lc;
+ 	bool		is_first = prefix == NULL ? false : true;
  
  	if (params)
  		*params = NIL;			/* initialize result list to empty */
***************
*** 841,862 **** appendWhereClause(StringInfo buf,
  	context.foreignrel = baserel;
  	context.buf = buf;
  	context.params_list = params;
  
  	/* Make sure any constants in the exprs are printed portably */
  	nestlevel = set_transmission_modes();
  
  	foreach(lc, exprs)
  	{
  		RestrictInfo *ri = (RestrictInfo *) lfirst(lc);
  
  		/* Connect expressions with "AND" and parenthesize each condition. */
  		if (is_first)
! 			appendStringInfoString(buf, " WHERE ");
  		else
  			appendStringInfoString(buf, " AND ");
  
  		appendStringInfoChar(buf, '(');
! 		deparseExpr(ri->clause, &context);
  		appendStringInfoChar(buf, ')');
  
  		is_first = false;
--- 1016,1051 ----
  	context.foreignrel = baserel;
  	context.buf = buf;
  	context.params_list = params;
+ 	context.outertlist = outertlist;
+ 	context.innertlist = innertlist;
  
  	/* Make sure any constants in the exprs are printed portably */
  	nestlevel = set_transmission_modes();
  
  	foreach(lc, exprs)
  	{
+ 		Node	   *node = (Node *) lfirst(lc);
  		RestrictInfo *ri = (RestrictInfo *) lfirst(lc);
+ 		Expr	   *expr = (Expr *) lfirst(lc);
+ 
+ 		if (IsA(node, RestrictInfo))
+ 		{
+ 			expr = ri->clause;
+ 		}
+ 		else
+ 		{
+ 			expr = ri->clause;
+ 			expr = (Expr *) node;
+ 		}
  
  		/* Connect expressions with "AND" and parenthesize each condition. */
  		if (is_first)
! 			appendStringInfoString(buf, prefix);
  		else
  			appendStringInfoString(buf, " AND ");
  
  		appendStringInfoChar(buf, '(');
! 		deparseExpr(expr, &context);
  		appendStringInfoChar(buf, ')');
  
  		is_first = false;
***************
*** 866,871 **** appendWhereClause(StringInfo buf,
--- 1055,1351 ----
  }
  
  /*
+  * Returns position index (start with 1) of given var in given target list, or
+  * 0 when not found.
+  */
+ static int
+ find_var_pos(Var *node, List *tlist)
+ {
+ 	int		pos = 1;
+ 	ListCell *lc;
+ 
+ 	foreach(lc, tlist)
+ 	{
+ 		Var *var = (Var *) lfirst(lc);
+ 
+ 		if (equal(var, node))
+ 		{
+ 			return pos;
+ 		}
+ 		pos++;
+ 	}
+ 
+ 	return 0;
+ }
+ 
+ /*
+  * Deparse given Var into buf.
+  */
+ static void
+ deparseJoinVar(Var *node, deparse_expr_cxt *context)
+ {
+ 	char		side;
+ 	int			pos;
+ 
+ 	pos = find_var_pos(node, context->outertlist);
+ 	if (pos > 0)
+ 		side = 'l';
+ 	else
+ 	{
+ 		side = 'r';
+ 		pos = find_var_pos(node, context->innertlist);
+ 	}
+ 
+ 	/*
+ 	 * We treat whole-row reference same as ordinary attribute references,
+ 	 * because such transformation should be done in lower level.
+ 	 */
+ 	appendStringInfo(context->buf, "%c.a%d", side, pos);
+ }
+ 
+ /*
+  * Deparse column alias list for a subquery in FROM clause.
+  */
+ static void
+ deparseColumnAliases(StringInfo buf, List *tlist)
+ {
+ 	int			pos;
+ 	ListCell   *lc;
+ 
+ 	pos = 1;
+ 	foreach(lc, tlist)
+ 	{
+ 		/* Deparse column alias for the subquery */
+ 		if (pos > 1)
+ 			appendStringInfoString(buf, ", ");
+ 		appendStringInfo(buf, "a%d", pos);
+ 		pos++;
+ 	}
+ }
+ 
+ /*
+  * Deparse "wrapper" SQL for a query which projects target lists in proper
+  * order and contents.  Note that this treatment is necessary only for queries
+  * used in FROM clause of a join query.
+  *
+  * Even if the SQL is enough simple (no ctid, no whole-row reference), the order
+  * of output column might different from underlying scan, so we always need to
+  * wrap the queries for join sources.
+  *
+  */
+ static const char *
+ deparseProjectionSql(PlannerInfo *root,
+ 					 RelOptInfo *baserel,
+ 					 const char *sql,
+ 					 char side)
+ {
+ 	StringInfoData wholerow;
+ 	StringInfoData buf;
+ 	ListCell   *lc;
+ 	bool		first;
+ 	bool		have_wholerow = false;
+ 
+ 	/*
+ 	 * We have nothing to do if the targetlist contains no special reference,
+ 	 * such as whole-row and ctid.
+ 	 */
+ 	foreach(lc, baserel->reltargetlist)
+ 	{
+ 		Var		   *var = (Var *) lfirst(lc);
+ 		if (var->varattno == 0)
+ 		{
+ 			have_wholerow = true;
+ 			break;
+ 		}
+ 	}
+ 
+ 	/*
+ 	 * Construct whole-row reference with ROW() syntax
+ 	 */
+ 	if (have_wholerow)
+ 	{
+ 		RangeTblEntry *rte;
+ 		Relation		rel;
+ 		TupleDesc		tupdesc;
+ 		int				i;
+ 
+ 		/* Obtain TupleDesc for deparsing all valid columns */
+ 		rte = planner_rt_fetch(baserel->relid, root);
+ 		rel = heap_open(rte->relid, NoLock);
+ 		tupdesc = rel->rd_att;
+ 
+ 		/* Print all valid columns in ROW() to generate whole-row value */
+ 		initStringInfo(&wholerow);
+ 		appendStringInfoString(&wholerow, "ROW(");
+ 		first = true;
+ 		for (i = 1; i <= tupdesc->natts; i++)
+ 		{
+ 			Form_pg_attribute attr = tupdesc->attrs[i - 1];
+ 
+ 			/* Ignore dropped columns. */
+ 			if (attr->attisdropped)
+ 				continue;
+ 
+ 			if (!first)
+ 				appendStringInfoString(&wholerow, ", ");
+ 			first = false;
+ 
+ 			appendStringInfo(&wholerow, "%c.a%d", side,
+ 							 i - FirstLowInvalidHeapAttributeNumber);
+ 		}
+ 		appendStringInfoString(&wholerow, ")");
+ 
+ 		heap_close(rel, NoLock);
+ 	}
+ 
+ 	/*
+ 	 * Construct a SELECT statement which has the original query in its FROM
+ 	 * clause, and have target list entries in its SELECT clause.  The number
+ 	 * used in column aliases are attnum - FirstLowInvalidHeapAttributeNumber in
+ 	 * order to make all numbers positive even for system columns which have
+ 	 * minus value as attnum.
+ 	 */
+ 	initStringInfo(&buf);
+ 	appendStringInfoString(&buf, "SELECT ");
+ 	first = true;
+ 	foreach(lc, baserel->reltargetlist)
+ 	{
+ 		Var *var = (Var *) lfirst(lc);
+ 
+ 		if (!first)
+ 			appendStringInfoString(&buf, ", ");
+ 	
+ 		if (var->varattno == 0)
+ 			appendStringInfo(&buf, "%s", wholerow.data);
+ 		else
+ 			appendStringInfo(&buf, "%c.a%d", side,
+ 							 var->varattno - FirstLowInvalidHeapAttributeNumber);
+ 
+ 		first = false;
+ 	}
+ 	appendStringInfo(&buf, " FROM (%s) %c", sql, side);
+ 
+ 	return buf.data;
+ }
+ 
+ static const char *
+ get_jointype_name(JoinType jointype)
+ {
+ 	if (jointype == JOIN_INNER)
+ 		return "INNER";
+ 	else if (jointype == JOIN_LEFT)
+ 		return "LEFT";
+ 	else if (jointype == JOIN_RIGHT)
+ 		return "RIGHT";
+ 	else if (jointype == JOIN_FULL)
+ 		return "FULL";
+ 
+ 	/* not reached */
+ 	elog(ERROR, "unsupported join type %d", jointype);
+ }
+ 
+ /*
+  * Construct a SELECT statement which contains join clause.
+  *
+  * We also create an TargetEntry List of the columns being retrieved, which is
+  * returned to *fdw_scan_tlist.
+  *
+  * path_o, tl_o, sql_o are respectively path, targetlist, and remote query
+  * statement of the outer child relation.  postfix _i means those for the inner
+  * child relation.  jointype and joinclauses are information of join method.
+  * fdw_scan_tlist is output parameter to pass target list of the pseudo scan to
+  * caller.
+  */
+ void
+ deparseJoinSql(StringInfo buf,
+ 			   PlannerInfo *root,
+ 			   RelOptInfo *baserel,
+ 			   RelOptInfo *outerrel,
+ 			   RelOptInfo *innerrel,
+ 			   const char *sql_o,
+ 			   const char *sql_i,
+ 			   JoinType jointype,
+ 			   List *joinclauses,
+ 			   List *otherclauses,
+ 			   List **fdw_scan_tlist,
+ 			   List **retrieved_attrs)
+ {
+ 	StringInfoData selbuf;		/* buffer for SELECT clause */
+ 	StringInfoData abuf_o;		/* buffer for column alias list of outer */
+ 	StringInfoData abuf_i;		/* buffer for column alias list of inner */
+ 	int			i;
+ 	ListCell   *lc;
+ 	const char *jointype_str;
+ 	deparse_expr_cxt context;
+ 
+ 	context.root = root;
+ 	context.foreignrel = baserel;
+ 	context.buf = &selbuf;
+ 	context.params_list = NULL;
+ 	context.outertlist = outerrel->reltargetlist;
+ 	context.innertlist = innerrel->reltargetlist;
+ 
+ 	jointype_str = get_jointype_name(jointype);
+ 	*retrieved_attrs = NIL;
+ 
+ 	/* print SELECT clause of the join scan */
+ 	initStringInfo(&selbuf);
+ 	i = 0;
+ 	foreach(lc, baserel->reltargetlist)
+ 	{
+ 		Var		   *var = (Var *) lfirst(lc);
+ 		TargetEntry *tle;
+ 
+ 		if (i > 0)
+ 			appendStringInfoString(&selbuf, ", ");
+ 		deparseJoinVar(var, &context);
+ 
+ 		tle = makeTargetEntry((Expr *) var, i + 1, NULL, false);
+ 		if (fdw_scan_tlist)
+ 			*fdw_scan_tlist = lappend(*fdw_scan_tlist, tle);
+ 
+ 		*retrieved_attrs = lappend_int(*retrieved_attrs, i + 1);
+ 
+ 		i++;
+ 	}
+ 	if (i == 0)
+ 		appendStringInfoString(&selbuf, "NULL");
+ 
+ 	/*
+ 	 * Do pseudo-projection for an underlying scan on a foreign table, if a) the
+ 	 * relation is a base relation, and b) its targetlist contains whole-row
+ 	 * reference.
+ 	 */
+ 	if (outerrel->reloptkind == RELOPT_BASEREL)
+ 		sql_o = deparseProjectionSql(root, outerrel, sql_o, 'l');
+ 	if (innerrel->reloptkind == RELOPT_BASEREL)
+ 		sql_i = deparseProjectionSql(root, innerrel, sql_i, 'r');
+ 
+ 	/* Deparse column alias portion of subquery in FROM clause. */
+ 	initStringInfo(&abuf_o);
+ 	deparseColumnAliases(&abuf_o, outerrel->reltargetlist);
+ 	initStringInfo(&abuf_i);
+ 	deparseColumnAliases(&abuf_i, innerrel->reltargetlist);
+ 
+ 	/* Construct SELECT statement */
+ 	appendStringInfo(buf, "SELECT %s FROM", selbuf.data);
+ 	appendStringInfo(buf, " (%s) l (%s) %s JOIN (%s) r (%s)",
+ 					 sql_o, abuf_o.data, jointype_str, sql_i, abuf_i.data);
+ 	/* Append ON clause */
+ 	if (joinclauses)
+ 		appendConditions(buf, root, baserel,
+ 						 outerrel->reltargetlist, innerrel->reltargetlist,
+ 						 joinclauses,
+ 						 " ON ", NULL);
+ 	/* Append WHERE clause */
+ 	if (otherclauses)
+ 		appendConditions(buf, root, baserel,
+ 						 outerrel->reltargetlist, innerrel->reltargetlist,
+ 						 otherclauses,
+ 						 " WHERE ", NULL);
+ }
+ 
+ /*
   * deparse remote INSERT statement
   *
   * The statement text is appended to buf, and we also create an integer List
***************
*** 1025,1031 **** deparseReturningList(StringInfo buf, PlannerInfo *root,
  	{
  		appendStringInfoString(buf, " RETURNING ");
  		deparseTargetList(buf, root, rtindex, rel, attrs_used,
! 						  retrieved_attrs);
  	}
  	else
  		*retrieved_attrs = NIL;
--- 1505,1511 ----
  	{
  		appendStringInfoString(buf, " RETURNING ");
  		deparseTargetList(buf, root, rtindex, rel, attrs_used,
! 						  retrieved_attrs, false);
  	}
  	else
  		*retrieved_attrs = NIL;
***************
*** 1292,1297 **** deparseExpr(Expr *node, deparse_expr_cxt *context)
--- 1772,1779 ----
  /*
   * Deparse given Var node into context->buf.
   *
+  * If context has valid innerrel, this is invoked for a join conditions.
+  *
   * If the Var belongs to the foreign relation, just print its remote name.
   * Otherwise, it's effectively a Param (and will in fact be a Param at
   * run time).  Handle it the same way we handle plain Params --- see
***************
*** 1302,1340 **** deparseVar(Var *node, deparse_expr_cxt *context)
  {
  	StringInfo	buf = context->buf;
  
! 	if (node->varno == context->foreignrel->relid &&
! 		node->varlevelsup == 0)
  	{
! 		/* Var belongs to foreign table */
! 		deparseColumnRef(buf, node->varno, node->varattno, context->root);
  	}
  	else
  	{
! 		/* Treat like a Param */
! 		if (context->params_list)
  		{
! 			int			pindex = 0;
! 			ListCell   *lc;
! 
! 			/* find its index in params_list */
! 			foreach(lc, *context->params_list)
  			{
! 				pindex++;
! 				if (equal(node, (Node *) lfirst(lc)))
! 					break;
  			}
! 			if (lc == NULL)
  			{
! 				/* not in list, so add it */
! 				pindex++;
! 				*context->params_list = lappend(*context->params_list, node);
  			}
- 
- 			printRemoteParam(pindex, node->vartype, node->vartypmod, context);
- 		}
- 		else
- 		{
- 			printRemotePlaceholder(node->vartype, node->vartypmod, context);
  		}
  	}
  }
--- 1784,1829 ----
  {
  	StringInfo	buf = context->buf;
  
! 	if (context->foreignrel->reloptkind == RELOPT_JOINREL)
  	{
! 		deparseJoinVar(node, context);
  	}
  	else
  	{
! 		if (node->varno == context->foreignrel->relid &&
! 			node->varlevelsup == 0)
  		{
! 			/* Var belongs to foreign table */
! 			deparseColumnRef(buf, node->varno, node->varattno, context->root);
! 		}
! 		else
! 		{
! 			/* Treat like a Param */
! 			if (context->params_list)
  			{
! 				int			pindex = 0;
! 				ListCell   *lc;
! 
! 				/* find its index in params_list */
! 				foreach(lc, *context->params_list)
! 				{
! 					pindex++;
! 					if (equal(node, (Node *) lfirst(lc)))
! 						break;
! 				}
! 				if (lc == NULL)
! 				{
! 					/* not in list, so add it */
! 					pindex++;
! 					*context->params_list = lappend(*context->params_list, node);
! 				}
! 
! 				printRemoteParam(pindex, node->vartype, node->vartypmod, context);
  			}
! 			else
  			{
! 				printRemotePlaceholder(node->vartype, node->vartypmod, context);
  			}
  		}
  	}
  }
